//
//  SQTDModel.swift
//  SQToDo
//
//  Created by narita on 2018/05/06.
//  Copyright © 2018年 narita. All rights reserved.
//

import Foundation

class SQTDModel: NSObject, NSCoding
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    public required override init()
    {
        
    }
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    public func encode(with aCoder: NSCoder)
    {
        aCoder.encode(self.todoItems, forKey: "todoItems")
    }
    
    public required init?(coder aDecoder: NSCoder)
    {
        if let theTodoItems = aDecoder.decodeObject(forKey: "todoItems") as? Array<SQTDTodoItem>
        {
            self.todoItems = theTodoItems
        }
    }

    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    // 追加: 範囲外ならば、末尾に追加
    @objc func addTodoItem(at index: NSInteger)
    {
        if 0..<self.todoItems.count ~= index
        {
            // indexの後ろに追加
            self.mutableArrayValue(forKey: "todoItems").insert(SQTDTodoItem(), at: index)
        }
        else
        {            
            // 末尾に追加
            self.mutableArrayValue(forKey: "todoItems").add(SQTDTodoItem())
        }
    }
    
    // 削除: 範囲外ならば、何もしない。
    @objc func removeTodoItem(at index: NSInteger)
    {
        if 0..<self.todoItems.count ~= index
        {
            self.mutableArrayValue(forKey: "todoItems").remove(index)
        }
    }
    
    // 移動：Drag&Dropは面倒なので実装しない。
    
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    @objc var todoItems: Array<SQTDTodoItem> = Array()
    
    // MARK: - Utility methods
}
