//
//  SQTDTodoItem.swift
//  SQToDo
//
//  Created by narita on 2018/05/06.
//  Copyright © 2018年 narita. All rights reserved.
//

import Foundation

@objc(SQTDTodoItem)
class SQTDTodoItem: NSObject, NSCoding
{
    // MARK: - class methods
    
    // MARK: - init methods
    public required override init()
    {
        
    }

    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    public func encode(with aCoder: NSCoder)
    {
        aCoder.encode(self.text, forKey: "text")
        aCoder.encode(self.done, forKey: "done")
    }
    
    public required init?(coder aDecoder: NSCoder)
    {
        if let theText = aDecoder.decodeObject(forKey: "text") as? String
        {
            self.text = theText
        }
        
        self.done = aDecoder.decodeBool(forKey: "done")
    }
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    @objc var text: String = ""
    @objc var done: Bool   = false

    @objc class func keyPathsForValuesAffectingDoneString() -> Set<String>
    {
        return [ "done" ]
    }

    @objc var doneString: String
    {
        return self.done ? "☑︎" : "◻︎"
    }

    @objc class func keyPathsForValuesAffectingDoneAndTextString() -> Set<String>
    {
        return [ "done", "text" ]
    }

    @objc var doneAndTextString: String
    {
        return self.doneString + " " + self.text
    }

    // MARK: - Utility methods    
    
}
