//
//  GeneratePreviewForURL.swift
//  SQToDoQuickLook
//
//  Created by narita on 2018/05/09.
//Copyright © 2018年 narita. All rights reserved.
//

import Foundation
import CoreFoundation
import CoreServices
import QuickLook


@_cdecl("GeneratePreviewForURL")
func GeneratePreviewForURL(thisInterface:UnsafeRawPointer,
                                            preview: QLPreviewRequest,
                                            url: CFURL,
                                            contentTypeUTI: CFString,
                                            options: CFDictionary) -> OSStatus
{
    autoreleasepool
    {
        // このプラグインのバンドルが取れる。
        // QLPreviewRequestGetGeneratorBundle(preview).takeRetainedValue()
        
        if QLPreviewRequestIsCancelled(preview) { return }// キャンセル処理：autoreleasepoolのスコープを抜ける
        
        do
        {
            // ファイルの読み込みをここら辺で行う
            let theContentsData = try Data(contentsOf: url as URL)
            
            if let theModel = NSKeyedUnarchiver.unarchiveObject(with: theContentsData) as? SQTDModel
            {
                if QLPreviewRequestIsCancelled(preview) { return } // キャンセル処理：autoreleasepoolのスコープを抜ける
                
                // 読み込んだファイルのデータをもとに表示内容を作る
                let theData: CFData = theModel.todoItemsDoAndTextString.data(using: String.Encoding.utf8)! as CFData
                
                if QLPreviewRequestIsCancelled(preview) { return } // キャンセル処理：autoreleasepoolのスコープを抜ける
                
                let theProperties: CFDictionary = [
                    kQLPreviewPropertyTextEncodingNameKey: "UTF-8",
                    kQLPreviewPropertyAttachmentsKey: [:],
                    kQLPreviewPropertyMIMETypeKey: "text"
                    ] as CFDictionary
                
                QLPreviewRequestSetDataRepresentation(preview,
                                                      theData,
                                                      kUTTypePlainText,
                                                      theProperties)

            }
        }
        catch
        {
            
        }
        
        print("Preview in Swift")
    }
    

    return noErr
}

@_cdecl("CancelPreviewGeneration")
func CancelPreviewGeneration(thisInterface:UnsafeRawPointer,
                             preview: QLPreviewRequest) -> Void
{
    // Implement only if supported
}
