//
//  GetMetadataForFile.swift
//  SQTDSpotlight
//
//  Created by narita on 2018/05/10.
//  Copyright © 2018年 narita. All rights reserved.
//

import Foundation
import CoreFoundation
import CoreServices

@_cdecl("GetMetadataForFile")
func GetMetadataForFile(    thisInterface:  UnsafeRawPointer,
                            attributes:     CFMutableDictionary,
                            contentTypeUTI: CFString,
                            pathToFile:     CFString) -> DarwinBoolean
{
    var theResult: DarwinBoolean = false
    
    autoreleasepool
    {
        let theContentTypeUTI: String = contentTypeUTI as String

        switch theContentTypeUTI
        {
            case "com.mindto01s.macos.sqtddoc":
                
                let theContentsData = NSData(contentsOfFile: pathToFile as String)! as Data
                
                if let theModel = NSKeyedUnarchiver.unarchiveObject(with: theContentsData) as? SQTDModel
                {
                    let theTextContent: CFString = theModel.todoItemsTextString as CFString
                    
                    CFDictionaryAddValue(attributes,
                                         unsafeBitCast(kMDItemTextContent,
                                                       to: UnsafeRawPointer.self),
                                         unsafeBitCast(theTextContent,
                                                       to: UnsafeRawPointer.self))
                    theResult = true
                }

            default:
                theResult = false
        }
    }
    
    return theResult
}
