//
//  GenerateThumbnailForURL.swift
//  SQToDoQuickLook
//
//  Created by narita on 2018/05/09.
//Copyright © 2018年 narita. All rights reserved.
//

import Foundation
import CoreFoundation
import CoreServices
import QuickLook


@_cdecl("GenerateThumbnailForURL")
func GenerateThumbnailForURL(thisInterface:UnsafeRawPointer,
                                            thumbnail: QLThumbnailRequest,
                                            url: CFURL,
                                            contentTypeUTI: CFString,
                                            options: CFDictionary,
                                            maxSize: CGSize) -> OSStatus
{
    autoreleasepool
    {
        // このプラグインのバンドルが取れる。
        // QLThumbnailRequestGetGeneratorBundle(thumbnail).takeRetainedValue()
        
        if QLThumbnailRequestIsCancelled(thumbnail) { return } // キャンセル処理：autoreleasepoolのスコープを抜ける
        
        do
        {
            // ファイルの読み込みをここら辺で行う
            let theContentsData = try Data(contentsOf: url as URL)
            
            if let theModel = NSKeyedUnarchiver.unarchiveObject(with: theContentsData) as? SQTDModel
            {
                if QLThumbnailRequestIsCancelled(thumbnail) { return } // キャンセル処理：autoreleasepoolのスコープを抜ける
                
                // 読み込んだファイルのデータをもとに表示内容を作る
                
                let theData: CFData = theModel.todoItemsDoAndTextString.data(using: String.Encoding.utf8)! as CFData
                
                if QLThumbnailRequestIsCancelled(thumbnail) { return } // キャンセル処理：autoreleasepoolのスコープを抜ける
                
                let theProperties: CFDictionary = [
                    kQLPreviewPropertyTextEncodingNameKey: "UTF-8",
                    kQLPreviewPropertyAttachmentsKey: [:],
                    kQLPreviewPropertyMIMETypeKey: "text"
                    ] as CFDictionary
                
                QLThumbnailRequestSetThumbnailWithDataRepresentation(thumbnail,
                                                                     theData,
                                                                     kUTTypePlainText,
                                                                     [:] as CFDictionary,
                                                                     theProperties)

            }
        }
        catch
        {
            
        }
        print("Thumbnail in Swift");
    }
    
    return noErr
}

@_cdecl("CancelThumbnailGeneration")
func CancelThumbnailGeneration(thisInterface:UnsafeRawPointer,
                               thumbnail: QLThumbnailRequest) -> Void
{
    // Implement only if supported
}

